from gpiozero import Button
from time import sleep

# Define pins for the Hall sensors
MOTOR1_HALL_A = 17  # Update with actual GPIO pin for Motor 1, Channel A
MOTOR1_HALL_B = 27  # Update with actual GPIO pin for Motor 1, Channel B
MOTOR2_HALL_A = 22  # Update with actual GPIO pin for Motor 2, Channel A
MOTOR2_HALL_B = 23  # Update with actual GPIO pin for Motor 2, Channel B

# Create Button objects for sensors
motor1_hall_a = Button(MOTOR1_HALL_A, pull_up=True)
motor1_hall_b = Button(MOTOR1_HALL_B, pull_up=True)
motor2_hall_a = Button(MOTOR2_HALL_A, pull_up=True)
motor2_hall_b = Button(MOTOR2_HALL_B, pull_up=True)

# Callback functions for state changes
def motor1_channel_a_detected():
    print("Motor 1: Channel A pulse detected")

def motor1_channel_b_detected():
    print("Motor 1: Channel B pulse detected")

def motor2_channel_a_detected():
    print("Motor 2: Channel A pulse detected")

def motor2_channel_b_detected():
    print("Motor 2: Channel B pulse detected")

# Attach callbacks to each sensor
motor1_hall_a.when_pressed = motor1_channel_a_detected
motor1_hall_b.when_pressed = motor1_channel_b_detected
motor2_hall_a.when_pressed = motor2_channel_a_detected
motor2_hall_b.when_pressed = motor2_channel_b_detected

# Main loop
try:
    print("Monitoring Hall sensors for both motors. Press Ctrl+C to exit.")
    while True:
        sleep(0.1)  # Prevent excessive CPU usage

except KeyboardInterrupt:
    print("\nExiting program...")
