from gpiozero import PWMOutputDevice
from time import sleep

class Motor():
    def __init__(self, EnaA, In1A, In2A, EnaB, In1B, In2B):
        self.pwmA = PWMOutputDevice(EnaA)
        self.in1A = PWMOutputDevice(In1A)
        self.in2A = PWMOutputDevice(In2A)
        self.pwmB = PWMOutputDevice(EnaB)
        self.in1B = PWMOutputDevice(In1B) 
        self.in2B = PWMOutputDevice(In2B)
        
    def move(self, speed=0.5, turn=0, t=0):
        # Ensure speed and turn are within bounds
        speed = max(-1, min(1, speed))  # Clamp speed to [-1, 1]
        turn = max(-1, min(1, turn))    # Clamp turn to [-1, 1]
        
        # Calculate speed for each motor
        leftSpeed = speed - turn
        rightSpeed = speed + turn
        
        wheel_base = 0
        '''
        left_speed = speed - (turn* wheel_base / 2)
        right_speed = peed + (turn* wheel_base / 2)
        '''
        
        # Clamp motor speeds to [-1, 1]
        leftSpeed = max(-1, min(1, leftSpeed))
        rightSpeed = max(-1, min(1, rightSpeed))
        
        # Set left motor
        self.pwmA.value = abs(leftSpeed)
        self.in1A.value = leftSpeed > 0
        self.in2A.value = leftSpeed <= 0
        
        # Set right motor
        self.pwmB.value = abs(rightSpeed)
        self.in1B.value = rightSpeed > 0
        self.in2B.value = rightSpeed <= 0
        
        # Print debugging info
        print(f"Left Motor: Speed={leftSpeed}, Right Motor: Speed={rightSpeed}")
        
        sleep(t)
        
    def stop(self, t=0):
        self.pwmA.value = 0
        self.pwmB.value = 0
        sleep(t)

def main():
    #motor1.move(0.5, 0, 0.865)  # Move forward
    motor1.move(0.5, 0, 3)  # Move forward
    motor1.stop(1)
    '''
    motor1.move(-0.5, 0, 3)  # Move backward
    motor1.stop(1)
    motor1.move(0.5, 0.5, 3)  # Turn right
    motor1.stop(1)
    motor1.move(0.5, -0.5, 3)  # Turn left
    motor1.stop(1)
    '''

if __name__ == '__main__':
    motor1 = Motor(14, 15, 18,17 ,22 ,27 )
    main()
                                                                                                                                                           